//------------------------------------------------------------------------
// File : asdxDemoCameraImpl.h
// Desc : Asura Camera Implementation For Demo Application 
// Copyright(c) Project Asura. All right reserved.
//------------------------------------------------------------------------

//------------------------------------------------------------------------
// History
//------------------------------------------------------------------------
// <--> 2011/08/22 [Pocol] VK쐬
// <End>

#ifndef __ASURA_DIRECTX_DEMO_CAMERA_IMPL_H__
#define __ASURA_DIRECTX_DEMO_CAMERA_IMPL_H__

//------------------------------------------------------------------------
// Includes
//------------------------------------------------------------------------
#include "asdxDemoCamera.h"

namespace Asura {
namespace SampleProgram {

/////////////////////////////////////////////////////////////////////////
// DemoCameraImpl class
/////////////////////////////////////////////////////////////////////////
class DemoCameraImpl : public DemoCamera
{
    //-------------------------------------------------------------------
    // list of friend classes and methods
    //-------------------------------------------------------------------
    /* NOTHING */

private:
    //-------------------------------------------------------------------
    // private variables
    //-------------------------------------------------------------------
    D3DXVECTOR3 mPosition;
    D3DXVECTOR3 mDirection;
    D3DXVECTOR3 mUp;
    D3DXMATRIX  mView;

    //-------------------------------------------------------------------
    // private variables
    //-------------------------------------------------------------------
    /* NOTHING */

protected:
    //-------------------------------------------------------------------
    // protected variables
    //-------------------------------------------------------------------
    typedef struct _MouseState
    {
        int  cursorX;
        int  cursorY;
        bool isDrag;
    } MouseState;

    typedef struct _CbFields
    {
        int cursorX;
        int cursorY;
        int wheelDelta;
        bool isDownLeft;
        bool isDownRight;
        bool isDownMiddle;
        bool isDownSide1;
        bool isDownSide2;
    } CbFields;

    CbFields   mCbValue;
    MouseState mLeft;
    MouseState mRight;
    MouseState mMiddle;
    D3DXVECTOR2 mAngle;
    float       mDistance;

    //------------------------------------------------------------------
    // protected methods
    //------------------------------------------------------------------
    void ComputeAsThirdPersonCamera();

public:
    //------------------------------------------------------------------
    // public variables
    //------------------------------------------------------------------
    /* NOTHING */

    //------------------------------------------------------------------
    // public methods
    //------------------------------------------------------------------
    DemoCameraImpl();
    virtual ~DemoCameraImpl();
    void SetPosition( D3DXVECTOR3 position );
    void SetDirection( D3DXVECTOR3 direction );
    void SetUpVector( D3DXVECTOR3 up );
    void Compute();
    D3DXVECTOR3 GetPosition();
    D3DXVECTOR3 GetDirection();
    D3DXVECTOR3 GetUpVector();
    D3DXMATRIX  GetView();
    void OnMouse(
        bool isLeftDown,
        bool isRightDown,
        bool isMiddleDown,
        bool isSide1Down,
        bool isSide2Down,
        int  wheelData,
        int  x,
        int  y );
};

} // namespace SampleProgram
} // namespace Asura

#endif//__ASURA_DIRECTX_DEMO_CAMERA_H__